
//#include <iostream.h>
#include <stdarg.h>
#include <stdlib.h>
#include "Adlib.h"
#include "Cludge.h"

#include "platform.h"

// A hack.  See `ad_init_adlib_'.  (Move into `platform.h')
extern "C" {
  extern int f90_argc ;
  extern char** f90_argv ;
}

extern "C" {
  void ad_init_adlib_() ;
  void ad_finalize_adlib_() ;
  void ad_init_procs_(int*, int*, int*) ;
  void ad_delete_procs_(int*) ;
  void ad_proc_coord_(int*, int*) ;
  void ad_scalar_proc_(int*, int*) ;
  void ad_construct_array_(int*, void*, int*, int*, int**) ;
  void ad_delete_array_(int*, int**) ;
  void ad_remap_(void* dst_dat, int* dst_atr,
		 void* src_dat, int* src_atr, int* src_typ) ;
  void ad_gather_(void* dst_dat, int* dst_atr,
		  void* src_dat, int* src_atr, int* src_typ,
		  ...) ;
  void ad_scatter_(void* src_dat, int* src_atr,
		   void* dst_dat, int* dst_atr, int* dst_typ,
		   ...) ;

  void ad_dot_product_(void* r, void* a_dat, int* a_atr, int* a_typ,
				void* b_dat, int* b_atr, int* b_typ) ;
  void ad_matmul_(void* r_dat, int* r_atr,
		  void* a_dat, int* a_atr, int* a_typ,
		  void* b_dat, int* b_atr, int* b_typ) ;

  void ad_all_(void* r, void* mask_dat, int* mask_atr) ;
  void ad_any_(void* r, void* mask_dat, int* mask_atr) ;
  void ad_count_(void* r, void* mask_dat, int* mask_atr) ;

  void ad_all_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
		   int* dim) ;
  void ad_any_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
		   int* dim) ;
  void ad_count_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
		     int* dim) ;

  void ad_maxval_(void* res,
		  void* src_dat, int* src_atr, int* src_typ,
		  void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_minval_(void* res,
		  void* src_dat, int* src_atr, int* src_typ,
		  void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_sum_(void* res,
	       void* src_dat, int* src_atr, int* src_typ,
	       void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_product_(void* res,
		   void* src_dat, int* src_atr, int* src_typ,
		   void* msk_dat, int* msk_atr, int* msk_present) ;

  void ad_maxval_dim_(void* res_dat, int* res_atr,
		      void* src_dat, int* src_atr, int* src_typ,
		      int* dim,
		      void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_minval_dim_(void* res_dat, int* res_atr,
		      void* src_dat, int* src_atr, int* src_typ,
		      int* dim,
		      void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_sum_dim_(void* res_dat, int* res_atr,
		   void* src_dat, int* src_atr, int* src_typ,
		   int* dim,
		   void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_product_dim_(void* res_dat, int* res_atr,
		       void* src_dat, int* src_atr, int* src_typ,
		       int* dim,
		       void* msk_dat, int* msk_atr, int* msk_present) ;

  void ad_maxloc_(void* res_dat, int* res_atr,
                  void* src_dat, int* src_atr, int* src_typ,
                  void* msk_dat, int* msk_atr, int* msk_present) ;
  void ad_minloc_(void* res_dat, int* res_atr,
                  void* src_dat, int* src_atr, int* src_typ,
                  void* msk_dat, int* msk_atr, int* msk_present) ;

  void ad_spread_(void* res_dat, int* res_atr,
		  void* src_dat, int* src_atr, int* src_typ,
		  int* dim, int* dummy) ;
  void ad_transpose_(void* res_dat, int* res_atr,
		     void* src_dat, int* src_atr, int* src_typ) ;
  void ad_cshift_s_(void* res_dat, int* res_atr,
		    void* src_dat, int* src_atr, int* src_typ,
		    int* shf, int* dim) ;
  void ad_cshift_a_(void* res_dat, int* res_atr,
		    void* src_dat, int* src_atr, int* src_typ,
		    void* shf_dat, int* shf_atr, int* dim) ;
  void ad_eoshift_s_s_(void* res_dat, int* res_atr,
		       void* src_dat, int* src_atr, int* src_typ,
		       int* shf, void* bdr, int* dim) ;
  void ad_eoshift_s_a_(void* res_dat, int* res_atr,
		       void* src_dat, int* src_atr, int* src_typ,
		       int* shf, void* bdr_dat, int* bdr_atr, int* dim) ;
  void ad_eoshift_a_s_(void* res_dat, int* res_atr,
		       void* src_dat, int* src_atr, int* src_typ,
		       void* shf_dat, int* shf_atr, void* bdr, int* dim) ;
  void ad_eoshift_a_a_(void* res_dat, int* res_atr,
		       void* src_dat, int* src_atr, int* src_typ,
		       void* shf_dat, int* shf_atr, void* bdr_dat, int* bdr_atr,
		       int* dim) ;
  void ad_reshape_(void* res_dat, int* res_atr,
		   void* src_dat, int* src_atr, int* src_typ,
		   void* dummy1,  int* dummy2,
		   void* pad_dat, int* pad_atr, int* pad_present,
		   void* ord_dat, int* dummy4, int* ord_present) ;
}

extern "C" {
  int printf(char*, ...) ;
}

//void printArrayInt(char* procName, char* arrName, Frame* src) {
//
//  // debug
//
//  ProcessGroup* P = src->prc() ;
//
//  if(P->on()) {
//    switch(src->rnk()) {
//      case 1 : {
//	Array1<int>* Src = (Array1<int>*) src ;
//
//	Range* x = Src->rng(1) ;
//
//	for(x->where() ; *x ; (*x)++) {
//	  printf("%s: x = %d: %s = %d\n",
//		  procName, (*x)(), arrName, (*Src)(*x)) ;
//	} x->erewh() ;
//
//	break ;
//      }
//      case 2 : {
//	Array2<int>* Src = (Array2<int>*) src ;
//
//	Range* x = Src->rng(1) ;
//	Range* y = Src->rng(2) ;
//
//	for(x->where() ; *x ; (*x)++) {
//	  for(y->where() ; *y ; (*y)++) {
//	    printf("%s: x, y = %d, %d: %s = %d\n",
//                   procName, (*x)(), (*y)(), arrName, (*Src)(*x, *y)) ;
//	  } y->erewh() ;
//	} x->erewh() ;
//
//	break ;
//      }
//      default :
//	printf("printArrayInt: Can't print %s!\n", arrName) ;
//    }
//  } P->no() ;
//}

//void printArrayFloat(char* procName, char* arrName, Frame* src) {
//
//  // debug
//
//  ProcessGroup* P = src->prc() ;
//
//  if(P->on()) {
//    switch(src->rnk()) {
//      case 1 : {
//	Array1<float>* Src = (Array1<float>*) src ;
//
//	Range* x = Src->rng(1) ;
//
//	for(x->where() ; *x ; (*x)++) {
//	  printf("%s: x = %d: %s = %f\n",
//		  procName, (*x)(), arrName, (*Src)(*x)) ;
//	} x->erewh() ;
//
//	break ;
//      }
//      case 2 : {
//	Array2<float>* Src = (Array2<float>*) src ;
//
//	Range* x = Src->rng(1) ;
//	Range* y = Src->rng(2) ;
//
//	for(x->where() ; *x ; (*x)++) {
//	  for(y->where() ; *y ; (*y)++) {
//	    printf("%s: x, y = %d, %d: %s = %f\n",
//                   procName, (*x)(), (*y)(), arrName, (*Src)(*x, *y)) ;
//	  } y->erewh() ;
//	} x->erewh() ;
//
//	break ;
//      }
//      default :
//	printf("printArrayFloat: Can't print %s!\n", arrName) ;
//    }
//  } P->no() ;
//}

static int logical = MA_LOGICAL ;
static int integer = MA_INTEGER ;

void ad_init_adlib_() {

  // I'm going straight into the NAG F90 library to pick up the
  // values of `argc' and `argv'.  Aargh...v.
  //
  // There doesn't seem to be a sensible, portable alternative.
  // [This is probably a bug in the MPI definition].

  int argc = f90_argc ;
  char** argv = f90_argv ;

  AdlibInit(argc, argv) ;
}

void ad_finalize_adlib_() {
  AdlibFinalize() ;
}

void ad_init_procs_(int* handle, int* rank, int* shape) {
  *handle = (int) new Procs(*rank, shape) ;
}

void ad_delete_procs_(int* handle) {
  delete (Procs*) *handle ;
}

void ad_proc_coord_(int* handle, int* coords)
{
  Procs* p = (Procs *) *handle ;

  int rank = p->rnk() ;

  if(rank)
    for(int i = 0 ; i < p->rnk() ; i++)
      if(p->loc())
        coords [i] = p->dim(i + 1)->crd() ;
      else
        coords [i] = -1 ;
  else
    if(p->loc())
      *coords = 0 ;
    else
      *coords = -1 ;
}

void ad_scalar_proc_(int* handle, int* coords)
{
  // Appearances notwithstanding, this is a test whether we're on
  // the scalar process referenced by `handle'

  Procs* p = (Procs *) *handle ;

  if(p->loc())
    *coords = 0 ;
  else
    *coords = -1 ;
}

void ad_construct_array_(int* handle, void* dat, int* atr, int* typ,
                         int** vecSubscrMask = NULL) {
  ProcessGroup* procGrp ;

  const int attrs = atr [0] ;

  int typeLen ;

  // Following assignments are informed guesses.  (Move sizes into `platform.h')
  switch(*typ) {
    case MA_INTEGER :
      typeLen = sizeof(int) ;
      break ;
    case MA_REAL :
      typeLen = sizeof(float) ;
      break ;
    case MA_DP :
      typeLen = sizeof(double) ;
      break ;
    case MA_COMPLEX :
      typeLen = 2 * sizeof(float) ;
      break ;
    case MA_LOGICAL :
      typeLen = sizeof(int) ;
      break ;
    default :
      AdlibError("ad_construct_array_: unsupported element type\n") ;
  }

  const int data_rank   = (attrs & MA_ARRAY_RANK_MASK) >> MA_ARRAY_RANK_SHIFT;
  const int embed_rank  = (attrs & MA_EMBED_RANK_MASK) >> MA_EMBED_RANK_SHIFT;

  if(attrs & MA_DISTRIB) {
    Procs* p = (Procs*) atr [2] ;
    procGrp = new ProcessGroup(*p) ;
  }
  else
    procGrp = new ProcessGroup(*apg) ;

  int* vecs = atr + 3 ;

  // Compute `rank' 
  int* n = vecs + data_rank ;
  int rank = 0 ;
  for(int i_dat = 0 ; i_dat < data_rank ; i_dat++) {
    if(n [i_dat] != -1) rank++ ;
  }

  // Initialise `*vecSubsMask'.
  if(vecSubscrMask) {
    *vecSubscrMask = new int [rank] ;
    int i_arr = 0 ;
    for(i_dat = 0 ; i_dat < data_rank ; i_dat++) {
      (*vecSubscrMask) [i_arr] = (n [i_dat] == -2) ;
      if(n [i_dat] != -1) i_arr++ ;
    }
  }

  *handle = (int) new Cludge(typeLen, procGrp, rank,
                             data_rank, embed_rank, vecs, dat) ;

  delete procGrp ;
}

void ad_delete_array_(int* handle, int** vecSubscrMask = NULL) {
  delete (Cludge *) *handle ;
  if(vecSubscrMask) delete *vecSubscrMask ;
}


// Accumulation (under addition)...

static void ad_zeroInt(void* dat) {
  *((int*) dat) = 0 ;
}

static void ad_zeroFloat(void* dat) {
  *((float*) dat) = 0.0 ;
}

static void ad_zeroDouble(void* dat) {
  *((double*) dat) = 0.0 ;
}

static void ad_zeroComplex(void* dat) {
  float* fdat = (float*) dat ;

  fdat [0] = 0.0 ;
  fdat [1] = 0.0 ;
}

static void ad_accumInt(void* acc, void* val) {
  *((int*) acc) += *((int*) val) ;
}

static void ad_accumFloat(void* acc, void* val) {
  *((float*) acc) += *((float*) val) ;
}

static void ad_accumDouble(void* acc, void* val) {
  *((double*) acc) += *((double*) val) ;
}

static void ad_accumComplex(void* acc, void* val) {
  float* facc = (float*) acc ;
  float* fval = (float*) val ;

  facc [0] += fval [0] ;
  facc [1] += fval [1] ;
}

static void ad_accumIfIntInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((int*) acc) += *((int*) val) ;
}

static void ad_accumIfFloatInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((float*) acc) += *((float*) val) ;
}

static void ad_accumIfDoubleInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((double*) acc) += *((double*) val) ;
}

static void ad_accumIfComplexInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) {
    float* facc = (float*) acc ;
    float* fval = (float*) val ;

    facc [0] += fval [0] ;
    facc [1] += fval [1] ;
  }
}


// Multiplicative accumulation...

static void ad_unitInt(void* dat) {
  *((int*) dat) = 1 ;
}

static void ad_unitFloat(void* dat) {
  *((float*) dat) = 1.0 ;
}

static void ad_unitDouble(void* dat) {
  *((double*) dat) = 1.0 ;
}

static void ad_unitComplex(void* dat) {
  float* fdat = (float*) dat ;

  fdat [0] = 1.0 ;
  fdat [1] = 0.0 ;
}

static void ad_accumMulInt(void* acc, void* val) {
  *((int*) acc) *= *((int*) val) ;
}

static void ad_accumMulFloat(void* acc, void* val) {
  *((float*) acc) *= *((float*) val) ;
}

static void ad_accumMulDouble(void* acc, void* val) {
  *((double*) acc) *= *((double*) val) ;
}

static void ad_accumMulComplex(void* acc, void* val) {
  float* facc = (float*) acc ;
  float* fval = (float*) val ;

  facc [0] *= fval [0] ;
  facc [1] *= fval [1] ;
}

static void ad_accumMulIfIntInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((int*) acc) *= *((int*) val) ;
}

static void ad_accumMulIfFloatInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((float*) acc) *= *((float*) val) ;
}

static void ad_accumMulIfDoubleInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) *((double*) acc) *= *((double*) val) ;
}

static void ad_accumMulIfComplexInt(void* acc, void* val, void* msk) {
  if(*((int*) msk)) {
    float* facc = (float*) acc ;
    float* fval = (float*) val ;

    facc [0] *= fval [0] ;
    facc [1] *= fval [1] ;
  }
}


// Boolean accumulations...

static void ad_trueLogical(void* dat) {
  *((int*) dat) = 1 ;
}

static void ad_accumAndLogical(void* acc, void* val) {
  *((int*) acc) = *((int*) acc) && *((int*) val) ;
}

static void ad_falseLogical(void* dat) {
  *((int*) dat) = 0 ;
}

static void ad_accumOrLogical(void* acc, void* val) {
  *((int*) acc) = *((int*) acc) || *((int*) val) ;
}


// `Max' accumulation...

static void ad_mostNegInt(void* dat) {
  *((int*) dat) = MOST_NEG_INT ;
}

static void ad_mostNegFloat(void* dat) {
  *((float*) dat) = MOST_NEG_FLOAT ;
}

static void ad_mostNegDouble(void* dat) {
  *((double*) dat) = MOST_NEG_DOUBLE ;
}

static int ad_accumMaxInt(void* acc, void* val) {
  int* iacc = (int*) acc ;
  int* ival = (int*) val ;

  if(*ival >= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static int ad_accumMaxFloat(void* acc, void* val) {
  float* iacc = (float*) acc ;
  float* ival = (float*) val ;

  if(*ival >= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static int ad_accumMaxDouble(void* acc, void* val) {
  double* iacc = (double*) acc ;
  double* ival = (double*) val ;

  if(*ival >= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static void ad_accumMaxIfIntInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((int*) val) > *((int*) acc))
    *((int*) acc) = *((int*) val) ;
}

static void ad_accumMaxIfFloatInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((float*) val) > *((float*) acc))
    *((float*) acc) = *((float*) val) ;
}

static void ad_accumMaxIfDoubleInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((double*) val) > *((double*) acc))
    *((double*) acc) = *((double*) val) ;
}


// `Min' accumulation...

static void ad_mostPosInt(void* dat) {
  *((int*) dat) = MOST_POS_INT ;
}

static void ad_mostPosFloat(void* dat) {
  *((float*) dat) = MOST_POS_FLOAT ;
}

static void ad_mostPosDouble(void* dat) {
  *((double*) dat) = MOST_POS_DOUBLE ;
}

static int ad_accumMinInt(void* acc, void* val) {
  int* iacc = (int*) acc ;
  int* ival = (int*) val ;

  if(*ival <= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static int ad_accumMinFloat(void* acc, void* val) {
  float* iacc = (float*) acc ;
  float* ival = (float*) val ;

  if(*ival <= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static int ad_accumMinDouble(void* acc, void* val) {
  double* iacc = (double*) acc ;
  double* ival = (double*) val ;

  if(*ival <= *iacc) {
    *iacc = *ival ;
    return 1 ;
  }
  else
    return 0 ;
}

static void ad_accumMinIfIntInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((int*) val) < *((int*) acc))
    *((int*) acc) = *((int*) val) ;
}

static void ad_accumMinIfFloatInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((float*) val) < *((float*) acc))
    *((float*) acc) = *((float*) val) ;
}

static void ad_accumMinIfDoubleInt(void* acc, void* val, void* msk) {
  if(*((int*) msk) && *((double*) val) < *((double*) acc))
    *((double*) acc) = *((double*) val) ;
}


// ``Scalar product'' accumulation...

static void ad_accumProdIntInt(void* acc, void* arg1, void* arg2) {
  *((int*) acc) += *((int*) arg1) * *((int*) arg2) ;
}

static void ad_accumProdIntFloat(void* acc, void* arg1, void* arg2) {
  *((float*) acc) += *((int*) arg1) * *((float*) arg2) ;
}

static void ad_accumProdIntDouble(void* acc, void* arg1, void* arg2) {
  *((double*) acc) += *((int*) arg1) * *((double*) arg2) ;
}

static void ad_accumProdIntComplex(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg2 = (float*) arg2 ;

  facc [0] += *((int*) arg1) * farg2 [0] ;
  facc [1] += *((int*) arg1) * farg2 [1] ;
}

static void ad_accumProdFloatInt(void* acc, void* arg1, void* arg2) {
  *((float*) acc) += *((float*) arg1) * *((int*) arg2) ;
}

static void ad_accumProdFloatFloat(void* acc, void* arg1, void* arg2) {
  *((float*) acc) += *((float*) arg1) * *((float*) arg2) ;
}

static void ad_accumProdFloatDouble(void* acc, void* arg1, void* arg2) {
  *((float*) acc) += *((float*) arg1) * *((double*) arg2) ;
}

static void ad_accumProdFloatComplex(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg2 = (float*) arg2 ;

  facc [0] += *((float*) arg1) * farg2 [0] ;
  facc [1] += *((float*) arg1) * farg2 [1] ;
}

static void ad_accumProdDoubleInt(void* acc, void* arg1, void* arg2) {
  *((double*) acc) += *((double*) arg1) * *((int*) arg2) ;
}

static void ad_accumProdDoubleFloat(void* acc, void* arg1, void* arg2) {
  *((double*) acc) += *((double*) arg1) * *((float*) arg2) ;
}

static void ad_accumProdDoubleDouble(void* acc, void* arg1, void* arg2) {
  *((double*) acc) += *((double*) arg1) * *((double*) arg2) ;
}

static void ad_accumProdDoubleComplex(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg2 = (float*) arg2 ;

  facc [0] += *((double*) arg1) * farg2 [0] ;
  facc [1] += *((double*) arg1) * farg2 [1] ;
}

static void ad_accumProdComplexInt(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg1 = (float*) arg1 ;

  facc [0] += farg1 [0] * *((int*) arg2) ;
  facc [1] += farg1 [1] * *((int*) arg2) ;
}

static void ad_accumProdComplexFloat(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg1 = (float*) arg1 ;

  facc [0] += farg1 [0] * *((float*) arg2) ;
  facc [1] += farg1 [1] * *((float*) arg2) ;
}

static void ad_accumProdComplexDouble(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg1 = (float*) arg1 ;

  facc [0] += farg1 [0] * *((double*) arg2) ;
  facc [1] += farg1 [1] * *((double*) arg2) ;
}

static void ad_accumProdComplexComplex(void* acc, void* arg1, void* arg2) {
  float* facc  = (float*) acc ;
  float* farg1 = (float*) arg1 ;
  float* farg2 = (float*) arg2 ;

  facc [0] += farg1 [0] * farg2 [0] - farg1 [1] * farg2 [1] ;
  facc [1] += farg1 [1] * farg2 [0] + farg1 [0] * farg2 [1] ;
}

static void ad_accumOrAndLogicalLogical(void* acc, void* arg1, void* arg2) {
  *((int*) acc) = *((int*) acc) || (*((int*) arg1) && *((int*) arg2)) ;
}


// Compiler weirdness... this interface produces a parse error...
// 
// static void ad_matrixProdOps(void (**opZero)(void*),
//                              void (**opMulAccum)(void*, void*, void*),
//                              void (**opAccum)(void*, void*),
//                              int* typeLen,
//                              const int arg1Type,
//                              const int arg2Type) ;
 
static void ad_matrixProdOps(int* type, int* typeLen,
                             void (**opZero)(void*),
                             void (**opMulAccum)(void*, void*, void*),
                             void (**opAccum)(void*, void*),
                             const int arg1Type,
                             const int arg2Type) {
  switch(arg1Type) {
    case MA_INTEGER :
      switch(arg2Type) {
        case MA_INTEGER :
          *opZero     = &ad_zeroInt ;
          *opMulAccum = &ad_accumProdIntInt ;
          *opAccum    = &ad_accumInt ;
          *type       = MA_INTEGER ;
          *typeLen    = sizeof(int) ;
          break ;
        case MA_REAL :
          *opZero     = &ad_zeroFloat ;
          *opMulAccum = &ad_accumProdIntFloat ;
          *opAccum    = &ad_accumFloat ;
          *typeLen    = sizeof(float) ;
          *type       = MA_REAL ;
          break ;
        case MA_DP :
          *opZero     = &ad_zeroDouble ;
          *opMulAccum = &ad_accumProdIntDouble ;
          *opAccum    = &ad_accumDouble ;
          *typeLen    = sizeof(double) ;
          *type       = MA_DP ;
          break ;
        case MA_COMPLEX :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdIntComplex ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_LOGICAL :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        default :
          AdlibError("ad_matrixProdOps: unsupported element type\n") ;
      }
      break ;
    case MA_REAL :
      switch(arg2Type) {
        case MA_INTEGER :
          *opZero     = &ad_zeroFloat ;
          *opMulAccum = &ad_accumProdFloatInt ;
          *opAccum    = &ad_accumFloat ;
          *type       = MA_REAL ;
          *typeLen    = sizeof(float) ;
          break ;
        case MA_REAL :
          *opZero     = &ad_zeroFloat ;
          *opMulAccum = &ad_accumProdFloatFloat ;
          *opAccum    = &ad_accumFloat ;
          *type       = MA_REAL ;
          *typeLen    = sizeof(float) ;
          break ;
        case MA_DP :
          *opZero     = &ad_zeroDouble ;
          *opMulAccum = &ad_accumProdFloatDouble ;
          *opAccum    = &ad_accumDouble ;
          *type       = MA_DP ;
          *typeLen    = sizeof(double) ;
          break ;
        case MA_COMPLEX :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdFloatComplex ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_LOGICAL :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        default :
          AdlibError("ad_matrixProdOps: unsupported element type\n") ;
      } ;
      break ;
    case MA_DP :
      switch(arg2Type) {
        case MA_INTEGER :
          *opZero     = &ad_zeroDouble ;
          *opMulAccum = &ad_accumProdDoubleInt ;
          *opAccum    = &ad_accumDouble ;
          *type       = MA_DP ;
          *typeLen    = sizeof(double) ;
          break ;
        case MA_REAL :
          *opZero     = &ad_zeroDouble ;
          *opMulAccum = &ad_accumProdDoubleFloat ;
          *opAccum    = &ad_accumDouble ;
          *type       = MA_DP ;
          *typeLen    = sizeof(double) ;
          break ;
        case MA_DP :
          *opZero     = &ad_zeroDouble ;
          *opMulAccum = &ad_accumProdDoubleDouble ;
          *opAccum    = &ad_accumDouble ;
          *type       = MA_DP ;
          *typeLen    = sizeof(double) ;
          break ;
        case MA_COMPLEX :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdDoubleComplex ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_LOGICAL :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        default :
          AdlibError("ad_matrixProdOps: unsupported element type\n") ;
      } ;
      break ;
    case MA_COMPLEX :
      switch(arg2Type) {
        case MA_INTEGER :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdComplexInt ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_REAL :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdComplexFloat ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_DP :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdComplexDouble ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_COMPLEX :
          *opZero     = &ad_zeroComplex ;
          *opMulAccum = &ad_accumProdComplexComplex ;
          *opAccum    = &ad_accumComplex ;
          *type       = MA_COMPLEX ;
          *typeLen    = 2 * sizeof(float) ;
          break ;
        case MA_LOGICAL :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        default :
          AdlibError("ad_matrixProdOps: unsupported element type\n") ;
      } ;
      break ;
    case MA_LOGICAL :
      switch(arg2Type) {
        case MA_INTEGER :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        case MA_REAL :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        case MA_DP :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        case MA_COMPLEX :
          AdlibError("ad_matrixProdOps: mixed numeric and logical type\n") ;
        case MA_LOGICAL :
          *opZero     = &ad_falseLogical ;
          *opMulAccum = &ad_accumOrAndLogicalLogical ;
          *opAccum    = &ad_accumOrLogical ;
          *type       = MA_LOGICAL ;
          *typeLen    = sizeof(int) ;
          break ;
        default :
          AdlibError("ad_matrixProdOps: unsupported element type\n") ;
      } ;
      break ;
    default :
      AdlibError("ad_matrixProdOps: unsupported element type\n") ;
  }
}


void ad_remap_(void* dst_dat, int* dst_atr,
               void* src_dat, int* src_atr, int* src_typ) {
  int src, dst ;

  ad_construct_array_(&src, src_dat, src_atr, src_typ) ;
  ad_construct_array_(&dst, dst_dat, dst_atr, src_typ) ;

  remap((Frame*) dst, (Frame*) src) ;

  ad_delete_array_(&dst) ;
  ad_delete_array_(&src) ;
}


void ad_gather_(void* dst_dat, int* dst_atr,
                void* src_dat, int* src_atr, int* src_typ,
                ...) {
  int src, dst ;
  int* vecSubscrMask ;

  ad_construct_array_(&src, src_dat, src_atr, src_typ, &vecSubscrMask) ;
  ad_construct_array_(&dst, dst_dat, dst_atr, src_typ) ;

  {
    Frame* srcFrame = (Frame*) src ;
    Frame* dstFrame = (Frame*) dst ;

    const int rank = srcFrame->rnk() ; 

    Array1<int>** subscripts = new Array1<int>* [rank] ;
    {
      va_list ap ;

      va_start(ap, src_typ) ;
      for (int i = 0; i < rank ; i++) {
        if(vecSubscrMask [i]) {
          void* sub_dat = va_arg(ap, void*) ;
          int*  sub_atr = va_arg(ap, int*)  ;
          int sub ;
          ad_construct_array_(&sub, sub_dat, sub_atr, &integer) ;
          subscripts [i] = (Array1<int>*) sub ;
        }
        else
          subscripts [i] = NULL ;
      }
      va_end(ap) ;
    }

    vecGather(dstFrame, srcFrame, subscripts) ;

    for (int i = 0; i < rank ; i++)
      if(vecSubscrMask [i])
        ad_delete_array_((int*) &subscripts [i]) ;
    delete subscripts ;
  }

  ad_delete_array_(&dst) ;
  ad_delete_array_(&src, &vecSubscrMask) ;
}


void ad_scatter_(void* src_dat, int* src_atr,
                 void* dst_dat, int* dst_atr, int* dst_typ,
                 ...) {
  int dst, src ;
  int* vecSubscrMask ;

  ad_construct_array_(&dst, dst_dat, dst_atr, dst_typ, &vecSubscrMask) ;
  ad_construct_array_(&src, src_dat, src_atr, dst_typ) ;

  {
    Frame* dstFrame = (Frame*) dst ;
    Frame* srcFrame = (Frame*) src ;

    const int rank = dstFrame->rnk() ; 

    Array1<int>** subscripts = new Array1<int>* [rank] ;
    {
      va_list ap ;

      va_start(ap, dst_typ) ;
      for (int i = 0; i < rank ; i++) {
        if(vecSubscrMask [i]) {
          void* sub_dat = va_arg(ap, void*) ;
          int*  sub_atr = va_arg(ap, int*)  ;
          int sub ;
          ad_construct_array_(&sub, sub_dat, sub_atr, &integer) ;
          subscripts [i] = (Array1<int>*) sub ;
        }
        else
          subscripts [i] = NULL ;
      }
      va_end(ap) ;
    }

    vecScatter(srcFrame, dstFrame, subscripts) ;

    for (int i = 0; i < rank ; i++)
      if(vecSubscrMask [i])
        ad_delete_array_((int*) &subscripts [i]) ;
    delete subscripts ;
  }

  ad_delete_array_(&src) ;
  ad_delete_array_(&dst, &vecSubscrMask) ;
}


void ad_dot_product_(void* r, void* a_dat, int* a_atr, int* a_typ,
                              void* b_dat, int* b_atr, int* b_typ) {
  // This actually supports dot product of any two arrays of the
  // same shape and mapping, not just rank-1.

  void (*opZero)(void*) ;
  void (*opMulAccum)(void*, void*, void*) ;
  void (*opAccum)(void*, void*) ;
  int type, typeLen ;

  ad_matrixProdOps(&type, &typeLen, &opZero, &opMulAccum, &opAccum,
                   *a_typ, *b_typ) ;

  int a, b ;

  ad_construct_array_(&a, a_dat, a_atr, a_typ) ;
  ad_construct_array_(&b, b_dat, b_atr, b_typ) ;

  if(a_atr [0] & MA_DISTRIB)  // a is distributed
    reduce2(typeLen, (char*) r, (Frame*) a, (Frame*) b,
            opZero, opMulAccum, opAccum) ;
  else
    reduce2(typeLen, (char*) r, (Frame*) b, (Frame*) a,
            opZero, opMulAccum, opAccum) ;
      // flip args, so mapping of computation picked by from `b'

  ad_delete_array_(&a) ;
  ad_delete_array_(&b) ;
}


void ad_matmul_(void* r_dat, int* r_atr,
                void* a_dat, int* a_atr, int* a_typ,
                void* b_dat, int* b_atr, int* b_typ) {

  // This is a quick fix---not very efficient.

  void (*opZero)(void*) ;
  void (*opMulAccum)(void*, void*, void*) ;
  void (*opAccum)(void*, void*) ;
  int type, typeLen ;

  ad_matrixProdOps(&type, &typeLen, &opZero, &opMulAccum, &opAccum,
                   *a_typ, *b_typ) ;

  Frame* a ;
  Frame* b ;
  Frame* r ;

  ad_construct_array_((int*) &a, a_dat, a_atr, a_typ) ;
  ad_construct_array_((int*) &b, b_dat, b_atr, b_typ) ;
  ad_construct_array_((int*) &r, r_dat, r_atr, &type) ;

  int l = a->rng(2)->size() ;  // size of intermediate dimension

  ProcessGroup* p = r->prc() ;

  Range* x = r->rng(1) ;
  Range* y = r->rng(2) ;

  Range z(l) ;                 // collapse intermediate dimension
  
  Data a_tmp(a->len(), p, 2, seq(x, &z)) ;
  Data b_tmp(b->len(), p, 2, seq(&z, y)) ;

  remap(&a_tmp, a) ;
  remap(&b_tmp, b) ;

  if(p->on()) {
    for(x->where() ; *x ; (*x)++) {
      char* aRow = a_tmp.dat() + a_tmp.str(1)->offset(x) ;
      char* rRow = r->dat()    + r->str(1)->offset(x) ;
      for(y->where() ; *y ; (*y)++) {
        char* bCol  = b_tmp.dat() + b_tmp.str(2)->offset(y) ;
        char* rElem = rRow        + r->str(2)->offset(y) ;

        // Inner loop simplified because range is primitive collapsed...

        char* aElem = aRow ;
        char* bElem = bCol ;

        z.locBlocksEnum() ;
        int aStep = a_tmp.str(2)->step(&z) ;
        int bStep = b_tmp.str(1)->step(&z) ;

        (*opZero)(rElem) ;
        for(int i = 0 ; i < l ; i++) {
          (*opMulAccum)(rElem, aElem, bElem) ;
          aElem += aStep ;
          bElem += bStep ;
        }
      } y->erewh() ;
    } x->erewh() ;
  } p->no() ;

  ad_delete_array_((int*) &r) ;
  ad_delete_array_((int*) &b) ;
  ad_delete_array_((int*) &a) ;
}


void ad_all_(void* r, void* mask_dat, int* mask_atr) {
  Frame* mask ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;

  reduce(sizeof(int), (char*) r, mask, &ad_trueLogical, &ad_accumAndLogical) ;
         
  ad_delete_array_((int*) &mask) ;
}

void ad_any_(void* r, void* mask_dat, int* mask_atr) {
  Frame* mask ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;

  reduce(sizeof(int), (char*) r, mask, &ad_falseLogical, &ad_accumOrLogical) ;
         
  ad_delete_array_((int*) &mask) ;
}

void ad_count_(void* r, void* mask_dat, int* mask_atr) {
  Frame* mask ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;

  reduce(sizeof(int), (char*) r, mask, &ad_zeroInt, &ad_accumInt) ;
         
  ad_delete_array_((int*) &mask) ;
}


void ad_all_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
                 int* dim) {
  Frame* mask ;
  Frame* r ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;
  ad_construct_array_((int*) &r, r_dat, r_atr, &logical) ;

  reduceDim(r, mask, *dim, &ad_trueLogical, &ad_accumAndLogical) ;
         
  ad_delete_array_((int*) &r) ;
  ad_delete_array_((int*) &mask) ;
}

void ad_any_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
                 int* dim) {
  Frame* mask ;
  Frame* r ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;
  ad_construct_array_((int*) &r, r_dat, r_atr, &logical) ;

  reduceDim(r, mask, *dim, &ad_falseLogical, &ad_accumOrLogical) ;
         
  ad_delete_array_((int*) &r) ;
  ad_delete_array_((int*) &mask) ;
}

void ad_count_dim_(void* r_dat, int* r_atr, void* mask_dat, int* mask_atr,
                   int* dim) {
  Frame* mask ;
  Frame* r ;
  ad_construct_array_((int*) &mask, mask_dat, mask_atr, &logical) ;
  ad_construct_array_((int*) &r, r_dat, r_atr, &logical) ;

  reduceDim(r, mask, *dim, &ad_zeroInt, &ad_accumInt) ;

  ad_delete_array_((int*) &r) ;
  ad_delete_array_((int*) &mask) ;
}


void ad_maxval_(void* res,
                void* src_dat, int* src_atr, int* src_typ,
                void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2(sizeof(int), (char*) res, src, msk,
            &ad_mostNegInt, &ad_accumMaxIfIntInt, 
            (void (*)(void*, void*)) &ad_accumMaxInt) ;
        break ;
      case MA_REAL :
        reduce2(sizeof(float), (char*) res, src, msk,
            &ad_mostNegFloat, &ad_accumMaxIfFloatInt,
            (void (*)(void*, void*)) &ad_accumMaxFloat) ;
        break ;
      case MA_DP :
        reduce2(sizeof(double), (char*) res, src, msk,
            &ad_mostNegDouble, &ad_accumMaxIfDoubleInt,
            (void (*)(void*, void*)) &ad_accumMaxDouble) ;
        break ;
      default :
        AdlibError("ad_maxval_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce(sizeof(int), (char*) res, src,
               &ad_mostNegInt, (void (*)(void*, void*)) &ad_accumMaxInt) ;
        break ;
      case MA_REAL :
        reduce(sizeof(float), (char*) res, src,
               &ad_mostNegFloat, (void (*)(void*, void*)) &ad_accumMaxFloat) ;
        break ;
      case MA_DP :
        reduce(sizeof(double), (char*) res, src,
               &ad_mostNegDouble, (void (*)(void*, void*)) &ad_accumMaxDouble) ;
        break ;
      default :
        AdlibError("ad_maxval_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &src) ;
}


void ad_minval_(void* res,
                void* src_dat, int* src_atr, int* src_typ,
                void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2(sizeof(int), (char*) res, src, msk,
            &ad_mostPosInt, &ad_accumMinIfIntInt,
            (void (*)(void*, void*)) &ad_accumMinInt) ;
        break ;
      case MA_REAL :
        reduce2(sizeof(float), (char*) res, src, msk,
            &ad_mostPosFloat, &ad_accumMinIfFloatInt,
            (void (*)(void*, void*)) &ad_accumMinFloat) ;
        break ;
      case MA_DP :
        reduce2(sizeof(double), (char*) res, src, msk,
            &ad_mostPosDouble, &ad_accumMinIfDoubleInt,
            (void (*)(void*, void*)) &ad_accumMinDouble) ;
        break ;
      default :
        AdlibError("ad_minval_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce(sizeof(int), (char*) res, src,
               &ad_mostPosInt, (void (*)(void*, void*)) &ad_accumMinInt) ;
        break ;
      case MA_REAL :
        reduce(sizeof(float), (char*) res, src,
               &ad_mostPosFloat, (void (*)(void*, void*)) &ad_accumMinFloat) ;
        break ;
      case MA_DP :
        reduce(sizeof(double), (char*) res, src,
               &ad_mostPosDouble, (void (*)(void*, void*)) &ad_accumMinDouble) ;
        break ;
      default :
        AdlibError("ad_minval_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &src) ;
}


void ad_sum_(void* res,
             void* src_dat, int* src_atr, int* src_typ,
             void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2(sizeof(int), (char*) res, src, msk,
                &ad_zeroInt, &ad_accumIfIntInt, &ad_accumInt) ;
        break ;
      case MA_REAL :
        reduce2(sizeof(float), (char*) res, src, msk,
                &ad_zeroFloat, &ad_accumIfFloatInt, &ad_accumFloat) ;
        break ;
      case MA_DP :
        reduce2(sizeof(double), (char*) res, src, msk,
                &ad_zeroDouble, &ad_accumIfDoubleInt, &ad_accumDouble) ;
        break ;
      case MA_COMPLEX :
        reduce2(2 * sizeof(float), (char*) res, src, msk,
                &ad_zeroComplex, &ad_accumIfComplexInt, &ad_accumComplex) ;
        break ;
      default :
        AdlibError("ad_sum_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce(sizeof(int), (char*) res, src,
               &ad_zeroInt, &ad_accumInt) ;
        break ;
      case MA_REAL :
        reduce(sizeof(float), (char*) res, src,
               &ad_zeroFloat, &ad_accumFloat) ;
        break ;
      case MA_DP :
        reduce(sizeof(double), (char*) res, src,
               &ad_zeroDouble, &ad_accumDouble) ;
        break ;
      case MA_COMPLEX :
        reduce(2 * sizeof(float), (char*) res, src,
               &ad_zeroComplex, &ad_accumComplex) ;
        break ;
      default :
        AdlibError("ad_sum_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &src) ;
}


void ad_product_(void* res,
                 void* src_dat, int* src_atr, int* src_typ,
                 void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2(sizeof(int), (char*) res, src, msk,
                &ad_unitInt, &ad_accumMulIfIntInt, &ad_accumMulInt) ;
        break ;
      case MA_REAL :
        reduce2(sizeof(float), (char*) res, src, msk,
                &ad_unitFloat, &ad_accumMulIfFloatInt, &ad_accumMulFloat) ;
        break ;
      case MA_DP :
        reduce2(sizeof(double), (char*) res, src, msk,
                &ad_unitDouble, &ad_accumMulIfDoubleInt, &ad_accumMulDouble) ;
        break ;
      case MA_COMPLEX :
        reduce2(2 * sizeof(float), (char*) res, src, msk,
                &ad_unitComplex, &ad_accumMulIfComplexInt, &ad_accumMulComplex) ;
        break ;
      default :
        AdlibError("ad_product_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce(sizeof(int), (char*) res, src,
               &ad_unitInt, &ad_accumMulInt) ;
        break ;
      case MA_REAL :
        reduce(sizeof(float), (char*) res, src,
               &ad_unitFloat, &ad_accumMulFloat) ;
        break ;
      case MA_DP :
        reduce(sizeof(double), (char*) res, src,
               &ad_unitDouble, &ad_accumMulDouble) ;
        break ;
      case MA_COMPLEX :
        reduce(2 * sizeof(float), (char*) res, src,
               &ad_unitComplex, &ad_accumMulComplex) ;
        break ;
      default :
        AdlibError("ad_product_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &src) ;
}


void ad_maxval_dim_(void* res_dat, int* res_atr,
                    void* src_dat, int* src_atr, int* src_typ,
                    int* dim,
                    void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostNegInt, &ad_accumMaxIfIntInt,
            (void (*)(void*, void*)) &ad_accumMaxInt) ;
        break ;
      case MA_REAL :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostNegFloat, &ad_accumMaxIfFloatInt,
            (void (*)(void*, void*)) &ad_accumMaxFloat) ;
        break ;
      case MA_DP :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostNegDouble, &ad_accumMaxIfDoubleInt,
            (void (*)(void*, void*)) &ad_accumMaxDouble) ;
        break ;
      default :
        AdlibError("ad_maxval_dim_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduceDim(res, src, *dim, &ad_mostNegInt,
                  (void (*)(void*, void*)) &ad_accumMaxInt) ;
        break ;
      case MA_REAL :
        reduceDim(res, src, *dim, &ad_mostNegFloat,
                  (void (*)(void*, void*)) &ad_accumMaxFloat) ;
        break ;
      case MA_DP :
        reduceDim(res, src, *dim, &ad_mostNegDouble,
                  (void (*)(void*, void*)) &ad_accumMaxDouble) ;
        break ;
      default :
        AdlibError("ad_maxval_dim_: unsupported element type\n") ;
    }
         
         
  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}


void ad_minval_dim_(void* res_dat, int* res_atr,
                    void* src_dat, int* src_atr, int* src_typ,
                    int* dim,
                    void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostPosInt, &ad_accumMinIfIntInt,
            (void (*)(void*, void*)) &ad_accumMinInt) ;
        break ;
      case MA_REAL :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostPosFloat, &ad_accumMinIfFloatInt,
            (void (*)(void*, void*)) &ad_accumMinFloat) ;
        break ;
      case MA_DP :
        reduce2Dim(res, src, msk, *dim,
            &ad_mostPosDouble, &ad_accumMinIfDoubleInt,
            (void (*)(void*, void*)) &ad_accumMinDouble) ;
        break ;
      default :
        AdlibError("ad_minval_dim_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduceDim(res, src, *dim, &ad_mostPosInt,
                  (void (*)(void*, void*)) &ad_accumMinInt) ;
        break ;
      case MA_REAL :
        reduceDim(res, src, *dim, &ad_mostPosFloat,
                  (void (*)(void*, void*)) &ad_accumMinFloat) ;
        break ;
      case MA_DP :
        reduceDim(res, src, *dim, &ad_mostPosDouble,
                  (void (*)(void*, void*)) &ad_accumMinDouble) ;
        break ;
      default :
        AdlibError("ad_minval_dim_: unsupported element type\n") ;
    }
         
         
  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}


void ad_sum_dim_(void* res_dat, int* res_atr,
                 void* src_dat, int* src_atr, int* src_typ,
                 int* dim,
                 void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2Dim(res, src, msk, *dim,
            &ad_zeroInt, &ad_accumIfIntInt, &ad_accumInt) ;
        break ;
      case MA_REAL :
        reduce2Dim(res, src, msk, *dim,
            &ad_zeroFloat, &ad_accumIfFloatInt, &ad_accumFloat) ;
        break ;
      case MA_DP :
        reduce2Dim(res, src, msk, *dim,
            &ad_zeroDouble, &ad_accumIfDoubleInt, &ad_accumDouble) ;
        break ;
      case MA_COMPLEX :
        reduce2Dim(res, src, msk, *dim,
            &ad_zeroComplex, &ad_accumIfComplexInt, &ad_accumComplex) ;
        break ;
      default :
        AdlibError("ad_sum_dim_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduceDim(res, src, *dim, &ad_zeroInt, &ad_accumInt) ;
        break ;
      case MA_REAL :
        reduceDim(res, src, *dim, &ad_zeroFloat, &ad_accumFloat) ;
        break ;
      case MA_DP :
        reduceDim(res, src, *dim, &ad_zeroDouble, &ad_accumDouble) ;
        break ;
      case MA_COMPLEX :
        reduceDim(res, src, *dim, &ad_zeroComplex, &ad_accumComplex) ;
        break ;
      default :
        AdlibError("ad_sum_dim_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}


void ad_product_dim_(void* res_dat, int* res_atr,
                     void* src_dat, int* src_atr, int* src_typ,
                     int* dim,
                     void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduce2Dim(res, src, msk, *dim,
            &ad_unitInt, &ad_accumMulIfIntInt, &ad_accumMulInt) ;
        break ;
      case MA_REAL :
        reduce2Dim(res, src, msk, *dim,
            &ad_unitFloat, &ad_accumMulIfFloatInt, &ad_accumMulFloat) ;
        break ;
      case MA_DP :
        reduce2Dim(res, src, msk, *dim,
            &ad_unitDouble, &ad_accumMulIfDoubleInt, &ad_accumMulDouble) ;
        break ;
      case MA_COMPLEX :
        reduce2Dim(res, src, msk, *dim,
            &ad_unitComplex, &ad_accumMulIfComplexInt, &ad_accumMulComplex) ;
        break ;
      default :
        AdlibError("ad_product_: unsupported element type\n") ;
    }

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(src_atr [0] & MA_TYPE) {
      case MA_INTEGER :
        reduceDim(res, src, *dim, &ad_unitInt, &ad_accumMulInt) ;
        break ;
      case MA_REAL :
        reduceDim(res, src, *dim, &ad_unitFloat, &ad_accumMulFloat) ;
        break ;
      case MA_DP :
        reduceDim(res, src, *dim, &ad_unitDouble, &ad_accumMulDouble) ;
        break ;
      case MA_COMPLEX :
        reduceDim(res, src, *dim, &ad_unitComplex, &ad_accumMulComplex) ;
        break ;
      default :
        AdlibError("ad_product_: unsupported element type\n") ;
    }
         
  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}


void ad_maxloc_(void* res_dat, int* res_atr,
                void* src_dat, int* src_atr, int* src_typ,
                void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    AdlibError("ad_maxloc_: mask argument to MAXLOC not yet supported\n") ;

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(*src_typ) {
      case MA_INTEGER : {
        int dummy ;
        maxLoc(sizeof(int), (char*) &dummy, (int*) res_dat, src,
               &ad_mostNegInt, &ad_accumMaxInt) ;
        break ;
      }
      case MA_REAL : {
        float dummy ;
        maxLoc(sizeof(float), (char*) &dummy, (int*) res_dat, src,
               &ad_mostNegFloat, &ad_accumMaxFloat) ;
        break ;
      }
      case MA_DP : {
        double dummy ;
        maxLoc(sizeof(double), (char*) &dummy, (int*) res_dat, src,
               &ad_mostNegDouble, &ad_accumMaxDouble) ;
        break ;
      }
      default :
        AdlibError("ad_maxloc_: unsupported element type\n") ;
    }

  ad_delete_array_((int*) &src) ;
}


void ad_minloc_(void* res_dat, int* res_atr,
                void* src_dat, int* src_atr, int* src_typ,
                void* msk_dat, int* msk_atr, int* msk_present) {
  Frame* src ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;

  if(*msk_present) {
    Frame* msk ;
    ad_construct_array_((int*) &msk, msk_dat, msk_atr, &logical) ;

    AdlibError("ad_minloc_: mask argument to MINLOC not yet supported\n") ;

    ad_delete_array_((int*) &msk) ;
  }
  else
    switch(*src_typ) {
      case MA_INTEGER : {
        int dummy ;
        maxLoc(sizeof(int), (char*) &dummy, (int*) res_dat, src,
               &ad_mostPosInt, &ad_accumMinInt) ;
        break ;
      }
      case MA_REAL : {
        float dummy ;
        maxLoc(sizeof(float), (char*) &dummy, (int*) res_dat, src,
               &ad_mostPosFloat, &ad_accumMinFloat) ;
        break ;
      }
      case MA_DP : {
        double dummy ;
        maxLoc(sizeof(double), (char*) &dummy, (int*) res_dat, src,
               &ad_mostPosDouble, &ad_accumMinDouble) ;
        break ;
      }
      default :
        AdlibError("ad_minloc_: unsupported element type\n") ;
    }

  ad_delete_array_((int*) &src) ;
}


void ad_spread_(void* res_dat, int* res_atr,
                void* src_dat, int* src_atr, int* src_typ,
                int* dim, int* dummy) {

  // NB: final argument is ignored.  (Shape of result is known from its
  //     attribute vector.)

  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  const int tmp1Rank = src->rnk() ;
  Range** tmp1Shape  = new Range* [tmp1Rank] ;
  {
    for(int d = 1 ; d <= tmp1Rank ; d++)
      if(d < *dim)
        tmp1Shape [d - 1] = res->rng(d) ;
      else
        tmp1Shape [d - 1] = res->rng(d + 1) ;

    Data tmp1(src->len(), res->prc(), tmp1Rank, tmp1Shape) ;
    
    remap(&tmp1, src) ;

    Promotion tmp2(&tmp1, *dim, res->rng(*dim)) ;

    copy(res, &tmp2) ;
  }
  delete tmp1Shape ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}

void ad_transpose_(void* res_dat, int* res_atr,
                   void* src_dat, int* src_atr, int* src_typ) {

  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  {
    Range* x = src->rng(1) ;
    Range* y = src->rng(2) ;

    Promotion srcTrans(2, seq(y, x), src, seq(2, 1)) ;

    remap(res, &srcTrans) ;
  }

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}

void ad_cshift_s_(void* res_dat, int* res_atr,
                  void* src_dat, int* src_atr, int* src_typ,
                  int* shf, int* dim) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  shift(res, src, *shf, *dim, CYCL) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}

void ad_cshift_a_(void* res_dat, int* res_atr,
                  void* src_dat, int* src_atr, int* src_typ,
                  void* shf_dat, int* shf_atr, int* dim) {
  Frame* shf ;
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &shf, shf_dat, shf_atr, &integer) ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  skew(res, src, shf, *dim, CYCL) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
  ad_delete_array_((int*) &shf) ;
}

void ad_eoshift_s_s_(void* res_dat, int* res_atr,
                     void* src_dat, int* src_atr, int* src_typ,
                     int* shf, void* bdr, int* dim) {
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  {
    Promotion tmp(res->len(), res->prc(), res->rnk(), res->shp(), (char*) bdr) ;

    copy(res, &tmp) ;
  }

  shift(res, src, *shf, *dim, EDGE) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
}

void ad_eoshift_s_a_(void* res_dat, int* res_atr,
                     void* src_dat, int* src_atr, int* src_typ,
                     int* shf, void* bdr_dat, int* bdr_atr, int* dim) {
  Frame* bdr ;
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &bdr, bdr_dat, bdr_atr, src_typ) ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  {
    Promotion tmp(bdr, *dim, res->rng(*dim)) ;

    copy(res, &tmp) ;
  }

  shift(res, src, *shf, *dim, EDGE) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
  ad_delete_array_((int*) &bdr) ;
}

void ad_eoshift_a_s_(void* res_dat, int* res_atr,
                     void* src_dat, int* src_atr, int* src_typ,
                     void* shf_dat, int* shf_atr, void* bdr, int* dim) {
  Frame* shf ;
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &shf, shf_dat, shf_atr, &integer) ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  {
    Promotion tmp(res->len(), res->prc(), res->rnk(), res->shp(), (char*) bdr) ;

    copy(res, &tmp) ;
  }

  skew(res, src, shf, *dim, EDGE) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
  ad_delete_array_((int*) &shf) ;
}

void ad_eoshift_a_a_(void* res_dat, int* res_atr,
                     void* src_dat, int* src_atr, int* src_typ,
                     void* shf_dat, int* shf_atr, void* bdr_dat, int* bdr_atr,
                     int* dim) {
  Frame* bdr ;
  Frame* shf ;
  Frame* src ;
  Frame* res ;
  ad_construct_array_((int*) &bdr, bdr_dat, bdr_atr, src_typ) ;
  ad_construct_array_((int*) &shf, shf_dat, shf_atr, &integer) ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  {
    Promotion tmp(bdr, *dim, res->rng(*dim)) ;

    copy(res, &tmp) ;
  }

  skew(res, src, shf, *dim, EDGE) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
  ad_delete_array_((int*) &shf) ;
  ad_delete_array_((int*) &bdr) ;
}


void ad_reshape_(void* res_dat, int* res_atr,
                 void* src_dat, int* src_atr, int* src_typ,
                 void* dummy1,  int* dummy2,
                 void* pad_dat, int* pad_atr, int* pad_present,
                 void* ord_dat, int* dummy4, int* ord_present) {

  // NB: Shape arguments are ignored (shape of result is known from its
  //     attribute vector.)
  //
  //      `order_mapvec' argument is ignored (`order' is known to be
  //      of global vector of length equal to the rank of `res').

  Frame* pad = NULL ;
  Frame* src ;
  Frame* res ;
  if(*pad_present)
    ad_construct_array_((int*) &pad, pad_dat, pad_atr, src_typ) ;
  ad_construct_array_((int*) &src, src_dat, src_atr, src_typ) ;
  ad_construct_array_((int*) &res, res_dat, res_atr, src_typ) ;

  if(*ord_present) {
    int* ord = (int*) ord_dat ;

    int dst_rnk = res->rnk() ;
    Range** dst_rngs = new Range* [dst_rnk] ;
    for(int i = 0 ; i < dst_rnk ; i++)
      dst_rngs [ord [i] - 1] = res->rng(i + 1) ;

    Promotion dst(dst_rnk, dst_rngs, res, ord) ;
        // No idea whether I have the permutation the right way round here.
        // I can't work it out from the F90 definition.

    reshape(&dst, src, pad) ;

    delete dst_rngs ;
  }
  else
    reshape(res, src, pad) ;

  ad_delete_array_((int*) &res) ;
  ad_delete_array_((int*) &src) ;
  if(*pad_present)
    ad_delete_array_((int*) &pad) ;
}


